;*********************************************************************
;  Read ADC liest TABELLE mit ADC-Daten voll (200 Samples)
;
;  Scratch-Reg: -
;*********************************************************************

read_adc:

#ifndef _LCD_MEM_							; Display im Memory Mapped Mode
		clr		TEMP_A
		out		ADC_D_DIR,TEMP_A			; auf Eingang
#endif
		load_p	X,TABELLE
		ldi	TEMP_B,GFX_SPALTEN

#ifdef _LCD_MEM_							; Display im Memory Mapped Mode
		in		TEMP_C,MCUCR
		cbr		TEMP_C,(1<<SRE)					; ext. Ram aus
		out		MCUCR,TEMP_C
#endif

read_adc_trigger_1:
		rcall	get_adc_data	
		cp		TEMP_A,TRIGGER_L
		brlo	read_adc_trigger_1			; zu klein Triggerwert, weiter warten...

		rcall	get_adc_data	
		cp		TEMP_A,TRIGGER_L
		brlo	read_adc_trigger_1			; wird kleiner.....

read_adc_trigger_2:
		rcall	get_adc_data
		cp		TEMP_A,TRIGGER_H
		brlo	read_adc_trigger_2			; noch kein Triggerwert, weiter warten..

read_adc_loop:
#ifdef _LCD_MEM_							; Display im Memory Mapped Mode
		in		TEMP_C,MCUCR
		cbr		TEMP_C,(1<<SRE)					; ext. Ram aus
		out		MCUCR,TEMP_C
#endif
		cbi		ADC_C_PORT,ADC_CS			; ADC aktiv
		cbi		ADC_C_PORT,IO_WR			; starten
		sbi		ADC_C_PORT,IO_WR
		cbi		ADC_C_PORT,IO_RD
		nop
		nop
		nop
		in		TEMP_A,ADC_D_IN				; Daten holen	
		sbi		ADC_C_PORT,IO_RD
		sbi		ADC_C_PORT,ADC_CS			; wieder inaktiv
; ldi	TEMP_A,100
#ifdef _LCD_MEM_							; Display im Memory Mapped Mode
		in		TEMP_C,MCUCR
		sbr		TEMP_C,(1<<SRE)
		out		MCUCR,TEMP_C				; Ram wieder ein
#endif
		st		X+,TEMP_A

		dec		TEMP_B
		brne	read_adc_loop

#ifndef _LCD_MEM_							; Display im Memory Mapped Mode
		ser		TEMP_A
		out		ADC_D_DIR,TEMP_A			; auf Eingang
#endif

        ret

;*********************************************************************
;  Holt Wert vom ADC fr Trigger
;
;  Scratch-Reg: -
;*********************************************************************

get_adc_data:
		cbi		ADC_C_PORT,ADC_CS			; ADC aktiv
		cbi		ADC_C_PORT,IO_WR			; starten
		sbi		ADC_C_PORT,IO_WR
		nop
		nop
		nop
		cbi		ADC_C_PORT,IO_RD
		nop
		nop
		nop
		in		TEMP_A,ADC_D_IN				; Daten holen	
		sbi		ADC_C_PORT,IO_RD
		sbi		ADC_C_PORT,ADC_CS

		ret
