
; AT90S8515

; Version v0.3 30.07.2006 M'Soft Berlin

; Umgestellt auf 6 Pixel FONT_SIZE, Text sieht so besser aus.
; Ein paar Aufrmarbeiten dazu...

#define _LCD_MEM_					; Display Memory Mapped
; wenn obiges #define auskommentiert wird, wird LCD am Port assembliert

#define _EXT_RAM_					; externer Ram vorhanden
; wenn obiges #define auskommentiert wird, wird nur der interne Ram benutzt
; !!! Im Moment mu auch _LCD_MEM_ definiert sein, wenn externes Ram benutzt wird !!!


.include "m8515def.inc"

; programmierte FUSE: SUT0  - Quarz - Slowly Rising Power 

; Definitionen

; Zuordnungen Ram-Adressen - LCD - Ram
;		Ram 8x	Display
; A0	A0		-
; A1	A1		-
; A2	A2		-
; A3	A3		-
; A4	A4		-
; A5	A5		-
; A6	A6		-
; A7	A7		-
; A8	A8		-
; A9	A9		-
; A10	A10		-
; A11	A11		-
; A12	A12		C_D
; A13	CE2		_CE
; A14	-		
; A15	_CE1	-


; Belegungen der Atmel-Ports:

;*****************************************************************

;	PA0-PA7		LCD D0 - D7, Ram D0 -D7, A/D-Wandler D0 - D7, Digital In D0 - D7

;	PB0-PB7		Triggerwort Digital/Analog Out, Counter H/L Read (Latch), Tasten ?	

;	PC0		A8		frei			Adresse Display:	Kommando $9000
;	PC1		A9		frei								Daten	 $8000
;	PC2		A10		frei
;	PC3		A11		frei			Adresse Ram:		$2000 - $3FFFF (8k)
;	PC4		A12		LCD_CD			Achtung! NUR diese Adressen benutzen, sonst kann es Kollisionen geben!!!
;	PC5		A13		RAM_CE2, LCD_CE
;	PC6		A14		frei
;	PC7		A15		RAM_CE1

;	PD0		RxD		frei	LCD_RE	(vorlufig)
;	PD1		TxD		frei	DIG_OE					; Digital In
;	PD2		INT0	frei	CountL	OE ?
;	PD3		INT1	frei	CountH  OE ?
;	PD4		XCK		frei			ADC_OV
;	PD5		OC1A	frei			ADC_CS
;	PD6		WR		LCD_WR, RAM_WR, ADC_WR
;	PD7		RD		LCD_RD, RAM_OE,	ADC_RD

;	PE0		INT2	Messung Fertig ?	
;	PE1		ALE		Ram A0-A7 Latch
;	PE2		OC1B	Messung Start mit H	-> Ram Latch OE auf H

;*****************************************************************

;--- Allgemeines -----------------------------------------------

.equ    F_CPU           = 10000000
.equ    CYCLES_PER_US   = ((F_CPU+500000)/1000000)

.equ	TXT_BASE		= $0000
.equ	GFX_BASE		= $0300

.equ	FONT_SIZE		= 6						; !Sonderzeichen sind nur fr 6 Bit!

.equ	GFX_SPALTEN		= 240
.equ	SPALTEN			= GFX_SPALTEN/FONT_SIZE
.equ	GFX_ZEILEN		= 128
.equ	TXT_ZEILEN		= 128/8

.equ	OSZI_SPALTE		=  36					; erste Spalte Oszillogramm
.equ	OSZI_ENDE		= GFX_SPALTEN-4			; letzte Spalte Oszillogramm
.equ	OSZI_ZEILE		=   3					; erste Zeile Oszillogramm  (Wert 100)
.equ	OSZI_HOEHE		= 100					; letzte Zeile Oszillogramm (Wert   0)

;				0bxxxxxyyyyyyyyzzz
;	x - CHR_OFFSET
;   y - CHR_CODE
;   z = CHR_LINE

.equ	CHR_OFFSET		= 3
.equ	CHR_CODE		= $80				; erster Charakter
.equ	CHR_BASE		= (CHR_OFFSET<<11)+(CHR_CODE<<3)

.equ	CHR_ANZ			= 21				; Anzahl Zeichen, die definiert werden

;--- Flag-Werte --------------------------------------------------- 

;--- Display-Kommandos--------------------------------------------- 

.equ	TXTHOME			= $40				; Set Text Home Adresse
.equ	TXTAREA			= $41				; Set Text Area
.equ	GFXHOME			= $42				; Set Grafik Home Adresse
.equ	GFXAREA			= $43				; Set Grafik Area
.equ	OFFSETA			= $22				; Set Offset Adresse
.equ	ADPSET			= $24				; Set Adress-Zeiger
.equ	AWRON			= $B0				; Set Auto-Write ON
.equ	AWROFF			= $B2				; Set Auto-Write OFF
.equ	BITSET			= $F8				; Set Bit an Adresse
.equ	BITCLR			= $F0				; Clr Bit an Adresse
.equ 	WRITELCD		= $C4				; Schreibt Daten ohne Adresszeiger zu ndern		
.equ	WRITEINC		= $C0				; Schreibt Daten und erhht Adresszeiger um 1
.equ	WRITEDEC		= $C2				; Schreibt Daten und verringert Adresszeiger um 1

.equ	MODE			= 0b10000000		; Display an - Mode OR
.equ	MODE_EOR		= 0b00000001		; Display an - Mode EOR
.equ	MODE_AND		= 0b00000011		; Display an - Mode AND
.equ	MODE_ATTR		= 0b00000100		; Display an - Mode TEXT-ATTRIBUT
.equ	MODE_EXT_CG		= 0b00001000		; Display an - Mode EXTERNER CG

.equ	D_MODE			= 0b10010000		; Display-Mode
.equ	D_MODE_CUR		= 0b00000010		; Cursor an
.equ	D_MODE_CB		= 0b00000011		; Cursor und Blinken an

.equ	D_MODE_TXT		= 0b00000100		; Text an
.equ	D_MODE_GFX		= 0b00001000		; Grafik an
.equ	D_MODE_TXT_GFX	= 0b00001100		; Text und Grafik an

.equ	STAT_CMD		= 0
.equ	STAT_RW			= 1
.equ	STAT_R_AUTO		= 2
.equ	STAT_W_AUTO		= 3


;**************************** Ram-Reservierungen ******************

;--- Internes Ram -------------------------------------------------

.DSEG

#ifdef	_EXT_RAM_
.ORG    $2000    							; externe 8k
#else
.ORG	$0060
#endif
						
TABELLE:	.byte	GFX_SPALTEN		; Anzahl Grafik-Spalten

;**************************** Register-Bits **************************

.equ	IO_WR		= PD6					; Write		L
.equ	IO_RD		= PD7					; Read		L

;--- Digital In -------------------------------------------------------

.equ	DIG_D_PORT	= PORTA					; Digital-Daten
.equ	DIG_D_IN	= PINA

.equ	DIG_C_PORT	= PORTD
.equ	DIG_OE		= PD1					; Digital In L

;--- Display ----------------------------------------------------------

.equ	LCD_C1_PORT	= PORTD
.equ	LCD_RE		= PD0					; Reset		L

#ifdef _LCD_MEM_
.equ	LCD_CMD		= $9000
.equ	LCD_DAT		= $8000
#else
.equ	LCD_C2_PORT = PORTC
.equ	LCD_CD		= PC4					; Code/Data H/L
.equ	LCD_CE		= PC5					; Enable	L

.equ	LCD_D_OUT   = PORTA
.equ	LCD_D_IN    = PINA
.equ	LCD_D_DIR   = DDRA
#endif

;--- ADC ----------------------------------------------------------

.equ	ADC_C_PORT	= PORTD
.equ	ADC_CS		= PD5					; L

.equ	ADC_C_IN	= PIND
.equ	ADC_OV		= PD4					; Overflow vom ADC

.equ	ADC_D_IN	= PINA
.equ	ADC_D_DIR	= DDRA

;--- lower Register -----------------------------------------------

.def	MUL_LOW		= r0
.def	MUL_HIGH	= r1
	
;--- higher Register ----------------------------------------------

.def    TEMP_A      = r16                   ; temporres  8Bit-Register
.def    TEMP_B      = r17                   ; temporres  8Bit-Register
.def    TEMP_C      = r18                   ; temporres  8Bit-Register

.def	TRIGGER_L	= r24					; Triggerwort legt ersten Pegel fest
.def	TRIGGER_H	= r25					; wenn grer als TRIGGER_1 -> steigendes Signal

; r26/r27, r28/r29, r30/r31 fr X,Y,Z reserviert 

;--- Macros -------------------------------------------------------

.macro  load_p                  		    ; ldt 16Bit @1 nach @0 High und @0 Low

        ldi     @0H,HIGH(@1)
        ldi     @0L,LOW(@1)

.endmacro
